找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1360|回复: 0

[分享] Exception with GetPointAtDist

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-11 23:20:44 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Autodesk.AutoCAD.Geometry;
using AcBr = Autodesk.AutoCAD.BoundaryRepresentation;
using Autodesk.AutoCAD.Runtime;

namespace Autodesk.AutoCAD.DatabaseServices
{
   public static class PolylineExtensionMethods
   {
      /// <summary>
      ///
      /// Returns true if the given Polyline forms a
      /// closed boundary and its Closed property is
      /// false.
      ///
      /// The result is true if any of the
      /// following conditions are true:
      ///
      /// 1.  Any segment intersects any other segment.
      ///      Regardless of the value of the Closed property.
      ///
      /// 2.  Any vertex lies directly on any segment.
      ///     or is coincident with any other vertex,
      ///     including zero-length segments, regardless
      ///     of the value of the Closed property
      ///
      /// 3.  If the first and last vertices are coincident,
      ///     AND the PolyLine's Closed property is false,
      ///     the polyline is considered effectively closed.
      ///     
      ///  4. A Closed polyline with < 3 vertices.
      ///     
      /// The test is intended to be consistent with the
      /// REGION command's testing of boundary entities.
      ///     
      /// </summary>

      public static bool IsEffectivelyClosed( this Polyline pline )
      {
         int numverts = pline.NumberOfVertices;
         if( numverts < 3 )
            return pline.Closed;

         if( !pline.Closed && pline.StartPoint.IsEqualTo( pline.EndPoint ) )
            return true;

         Point3dCollection points = new Point3dCollection();

         pline.IntersectWith( pline, Intersect.OnBothOperands, points,
            IntPtr.Zero, IntPtr.Zero );

         if( !pline.Closed )
            numverts -= 2;

         return points.Count != numverts;
      }
   }
}

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-5-23 01:18 , Processed in 0.357579 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表